program translit;


uses
  SysUtils,
  Windows;

 {$R *.res}

type
TTranslitFile= Function(InputFile,OutputFile,CodeTable:PChar):integer; stdcall;

var
 FROMFILE,TOFILE,CODETABLE:string;
 x:pchar;
 location:shortstring;
 LibHWND:HWND;
 TTF:TTranslitFile;
 ListEncode:Boolean;
 List:textFile;
 listitem:string;

begin
 GetMem (x,max_path);
 GetModuleFilename (hInstance,x,max_path);
 Location:=x;
 FreeMem(x);
 FROMFILE:=Paramstr (1);
 TOFILE:=Paramstr (2);
 CODETABLE:=Paramstr (3);
 if (LowerCase(FROMFILE)='-l') and (fileexists(TOFILE)) then //%L
  begin
  ListEncode:=true;
  end else
 if (CODETABLE='') and (fileexists(TOFILE)) then
  begin
  CODETABLE:=TOFILE;
  TOFILE:=FROMFILE+'.out';
  end else
 if (FROMFILE='') or (FROMFILE='?') then
  begin
  MessageBox (GetForegroundWindow,'Usage:'+#10+#10+
  'translit.exe fromfile tofile codetable'+#10+
  'or:'+#10+
  'translit.exe fromfile codetable'+#10+
  'or'+#10+
  'translit.exe -l filelist codetable'+#10+#10+
  'Sample: translit.exe "c:\text_file.txt" "c:\transliterated_text_file.txt" "c:\total\plugins\wdx\translit\Rus2Lat (RINT).ttb"',
  'Usage',mb_ok+mb_IconInformation);
  halt;
  end;

if not ListEncode then
  begin
  try
  if (not fileexists(FROMFILE)) and (FROMFILE[2]<>':') then
   begin
   FROMFILE:=extractfilepath(location)+FROMFILE;
   end;
  except
  MessageBox (getForegroundWindow,pchar('Input file '+FROMFILE+' not found'),'Error',mb_ok+mb_iconInformation);
  halt;
  end;

  if not fileexists(FROMFILE) then
   begin
   MessageBox (getForegroundWindow,pchar('Input file '+FROMFILE+' not found'),'Error',mb_ok+mb_iconInformation);
   halt;
   end;

  try
  if (not fileexists(CODETABLE)) and (CODETABLE[2]<>':') then
   begin
   CODETABLE:=extractfilepath(location)+CODETABLE;
   end;
  except
  MessageBox (getForegroundWindow,pchar('Table file '+CODETABLE+' not found'),'Error',mb_ok+mb_iconInformation);
  halt;
  end;

  if not fileexists(CODETABLE) then
   begin
   MessageBox (getForegroundWindow,pchar('Table file '+CODETABLE+' not found'),'Error',mb_ok+mb_iconInformation);
   halt;
   end;
end;

  if not fileexists(extractfilepath(location)+'wdx_translit.wdx') then
   begin
   MessageBox (getForegroundWindow,pchar('Transliteration plugin wdx_translit.wdx not found'),'Error',mb_ok+mb_iconInformation);
   halt;
   end else
   begin
   LibHWND:=LoadLibrary (pchar(extractfilepath(location)+'wdx_translit.wdx'));
   if LibHWND=0 then
    begin
    MessageBox (getForegroundWindow,pchar('Loading plugin error'),'Error',mb_ok+mb_iconInformation);
    halt;
    end;
   @TTF:=GetProcAddress(LibHWND, 'TranslitFile');
   if @TTF=NIL then
    begin
    MessageBox (getForegroundWindow,pchar('Old or unsupported wdx_translit.wdx version'),'Error',mb_ok+mb_iconInformation);
    halt;
    end;
    if not ListEncode then TTF (pchar(FROMFILE),pchar(TOFILE),pchar(CODETABLE)) else
     begin
     Assignfile (list, ToFile);
     reset (list);
     While not eof (list) do
      begin
      readln (list,listitem);
      TTF (pchar(listitem),pchar(listitem+'.out'),pchar(CODETABLE));
      end;
     end;
   end;
   FreeLibrary(LibHWND);

end.
